Subject: Re: bug#23006: 25.0.92; Loading Tramp breaks pcomplete in eshell-mode

From: Stefan Monnier <[email-masked]>
Date: Fri, 18 Mar 2016 12:13:28 -0400

>   tramp-send-command([#("scp" 0 3 (tramp-default t)) nil "adb" "" nil] "cd ~ && pwd")
>   tramp-sh-handle-expand-file-name("/adb:" "/")
>   apply(tramp-sh-handle-expand-file-name ("/adb:" "/"))
>   tramp-sh-file-name-handler(expand-file-name "/adb:" "/")
>   apply(tramp-sh-file-name-handler expand-file-name ("/adb:" "/"))
>   tramp-file-name-handler(expand-file-name "/adb:" "/")
>   expand-file-name("adb:" "/")
>   apply(expand-file-name ("adb:" "/"))
>   tramp-completion-run-real-handler(expand-file-name ("adb:" "/"))
>   tramp-completion-file-name-handler(expand-file-name "adb:" "/")
>   file-directory-p("adb:")

And I think here we have another related problem: (file-directory-p
"/adb:") should not try to connect to the "adb" host, because this name
is ambiguous.

A big part of the problem here is our support for the
"/<host>:" syntax.  I wonder if we could demote this syntax.  One option
is of course to drop it altogether (I'm biased: I never use it).
But maybe another is to only support it in substitute-in-file-name,
where it'd get expanded to its more verbose equivalent.

        Stefan